const { exec } = require('child_process');

// Function to execute a seeder file
function runSeeder(seederFile) {
  return new Promise((resolve, reject) => {
    console.log(`Running seeder: ${seederFile}`);
    exec(`node ${seederFile}`, (error, stdout, stderr) => {
      if (error) {
        console.error(`Error executing ${seederFile}: ${error}`);
        return reject(error);
      }
      console.log(stdout);
      console.error(stderr);
      resolve();
    });
  });
}

// Main function to run seeders in order
async function runSeeders() {
  try {
    // Run Access seeder
    await runSeeder('accessSeeder.js');
    console.log('Access seeder completed successfully');

    // Run Role seeder
    await runSeeder('roleSeeder.js');
    console.log('Role seeder completed successfully');

    //Run Skillset seeder
    await runSeeder('skillsetSeeder.js');
    console.log('Skillset seeder completed successfully');
    
    //Run SuperAdmin seeder
    await runSeeder('employeeSeeder.js');
    console.log('Employee seeder completed successfully');

    console.log('All seeders executed successfully');
  } catch (error) {
    console.error('An error occurred while running seeders:', error);
  }
}

// Run the main function
runSeeders();