const mongoose = require('mongoose');
const { Schema } = mongoose;

const accessSchema = new Schema({
  board: {
    activeProjects: { type: Boolean, default: false },
    team: { type: Boolean, default: false },
    resourcesOnBench: { type: Boolean, default: false },
    requestForResources: { type: Boolean, default: false },
    requestForResourcesAllocate: { type: Boolean, default: false },
    requestForExtensionApproveReject: { type: Boolean, default: false },
    myActions: { type: Boolean, default: false },
    alerts: { type: Boolean, default: false }
  },
  timesheet: {
    viewTimesheet: { type: Boolean, default: false },
    addTimeEntry: { type: Boolean, default: false },
    editTrackedOrEnteredTime: { type: Boolean, default: false },
    deleteTimesheet: { type: Boolean, default: false },
    trackTime: { type: Boolean, default: false },
    approveOrRejectTimesheet: { type: Boolean, default: false },
    submitTimesheet: { type: Boolean, default: false }
  },
  projects: {
    projectsListingActive: { type: Boolean, default: false },
    addProjects: { type: Boolean, default: false },
    editProjects: { type: Boolean, default: false },
    deleteProjects: { type: Boolean, default: false },
    projectsListingClosed: { type: Boolean, default: false },
    closeOfProject: { type: Boolean, default: false },
    reopenClosedProjects: { type: Boolean, default: false },
    viewTeam: { type: Boolean, default: false },
    addTeam: { type: Boolean, default: false },
    editTeam: { type: Boolean, default: false },
    deleteTeam: { type: Boolean, default: false },
    requestForAdditionalResources: { type: Boolean, default: false },
    requestForResourceApproveReject: { type: Boolean, default: false },
    requestForExtension: { type: Boolean, default: false },
    requestForExtensionApproveReject: { type: Boolean, default: false },
    viewMilestone: { type: Boolean, default: false },
    addMilestone: { type: Boolean, default: false },
    editMilestone: { type: Boolean, default: false },
    deleteMilestone: { type: Boolean, default: false },
    viewSkillset: { type: Boolean, default: false },
    addSkillset: { type: Boolean, default: false },
    deleteSkillset: { type: Boolean, default: false },
    viewCRFR: { type: Boolean, default: false },
    addCRFR: { type: Boolean, default: false },
    editCRFR: { type: Boolean, default: false },
    deleteCRFR: { type: Boolean, default: false },
    historyViewAll: { type: Boolean, default: false },
    historyViewAllocation: { type: Boolean, default: false },
    historyViewExtension: { type: Boolean, default: false }
  }, 
  team: {
    viewTeamListing: { type: Boolean, default: false },
    addNewTeamMember: { type: Boolean, default: false },
    editTeam: { type: Boolean, default: false },
    deleteTeam: { type: Boolean, default: false }
  },
  report:{
    employeeTimesheetReport : {type: Boolean, default: false},
    estimatedVsActualReport : {type: Boolean, default: false},
  },
  skillset: {
    viewSkillsetListing: { type: Boolean, default: false },
    addNewSkillset: { type: Boolean, default: false },
    deleteSkillset: { type: Boolean, default: false },
    editSkillset: { type: Boolean, default: false }
  },
  rolesAndAccess: {
    setAccessForDifferentRoles: { type: Boolean, default: false }
  }
}, { timestamps: true });

module.exports = mongoose.model('Access', accessSchema);
