const mongoose = require('mongoose');

const extensionSchema = new mongoose.Schema({
  projectTeamMember: { type: mongoose.Schema.Types.ObjectId, ref: 'ProjectTeamMember', required: true },
  priority: { type: String, enum: ['High', 'Medium', 'Low'], required: true },
  extendTill: { type: Date, required: true },
  status: { type: String, enum: ['pending', 'accepted', 'rejected'], default: 'pending' },
  history: [{
    status: { type: String, required: true },
    userRole: { type: String, required: true },
    updatedAt: { type: Date, default: Date.now }
  }]
});

module.exports = mongoose.model('Extension', extensionSchema);
