const mongoose = require('mongoose');
const { Schema } = mongoose;

const projectSchema = new Schema({
  name: { type: String, required: true },
  type: { type: String, required: true },
  from: { type: Date },
  end: { type: Date },
  initialStartDate: { type: Date},
  estimatedhours: { type: Number, required: true },
  workedhours: { type: Number, default: 0 },
  tam: { type: Schema.Types.ObjectId, ref: 'Employee',required: false},
  description: { type: String, required: true },
  closuredate: { type: Date, required: false },
  remarks: { type: String },
  milestone: [{ type: mongoose.Schema.Types.ObjectId, ref: 'Milestone' }],
  skillsets: [{ type: Schema.Types.ObjectId, ref: 'Skillset' }],
  visibility: { type: Boolean, default: true },
  isreopen:{ type: Boolean, default: false },
  requiredResources: [{
    requiredPost: { type: String, required: true },
    totalHours: { type: Number, required: true },
  }],
  booked: { type: Boolean, default: false },
  financeApproved: { type: Boolean, default: false },

});

const Project = mongoose.model('Project', projectSchema);
module.exports = Project;