const mongoose = require('mongoose');
const { Schema } = mongoose;
 
const projectTeamMemberSchema = new Schema({
  project: { type: Schema.Types.ObjectId, ref: 'Project', required: true },
  employee: { type: Schema.Types.ObjectId, ref: 'Employee', required: true },
  startDate: { type: Date, required: true },
  endDate: { type: Date, required: true },
  hoursAllocated: { type: Number, default: 0 },
  visibility: { type: Boolean, default: true }
},{ timestamps: true });

const ProjectTeamMember = mongoose.model('ProjectTeamMember', projectTeamMemberSchema);

module.exports = ProjectTeamMember;
