const mongoose = require('mongoose');

const allocationSchema = new mongoose.Schema({
  projectId: { type: mongoose.Schema.Types.ObjectId, ref: 'Project', required: true },
  skillSet: { type: mongoose.Schema.Types.ObjectId, ref: 'Skillset', required: true }, 
  numberOfEmployees: { type: Number, required: true },
  allocatedEmployees: { type: Number, default: 0 },
  startDate: { type: Date, required: true },
  endDate: { type: Date, required: true },
  priority: { type: String, required: true },
  status: { type: String, default: 'Pending' },
  requestedBy: { type: String, required: true }, 
  history: [{
    requestedEmployeeNames: { type: [String], required: true },
    updatedEmployeeRole: { type: String, required: true },
    status: { type: String, required: true },
    date: { type: Date, default: Date.now }
  }]
}, { timestamps: true });

const Allocation = mongoose.model('Allocation', allocationSchema);

module.exports = Allocation;