const reportRepository = require('../report.repository');

const getEmployeeTimeLogs = async (employeeId, projectId, start, end) => {
  let query = { employeeId, approved: true };

  if (projectId) {
    query.projectId = projectId;
  }

  if (start && end) {
    query.date = { $gte: new Date(start), $lte: new Date(end) };
  }


  return await reportRepository.getTimeLogs(query);
};

const getProjectTasks = async (projectId) => {
  try {
    const tasks = await reportRepository.getProjectTasks(projectId);
    return tasks;
  } catch (error) {
    console.error('Error in TaskService.getProjectTasks:', error);
    throw error;
  }
};

module.exports = {
  getEmployeeTimeLogs,
  getProjectTasks

};