const skillsetRepository = require('../skillset.repository');

const getSkillsetID = async (userId) => {
  return await skillsetRepository.findById(userId);
};

const getSkillset = async (search, page, limit) => {
  return await skillsetRepository.findAllWithSearchAndPagination(search, page, limit);
};

const addSkillset = async (skillsetData) => {

  return await skillsetRepository.create(skillsetData);
};

const editSkillset = async (id, skillsetData) => {
  return await skillsetRepository.updateById(id, skillsetData);
};

const deleteSkillset = async (id) => {
  return await skillsetRepository.deleteById(id);
};

module.exports = {
  getSkillset,
  addSkillset,
  editSkillset,
  deleteSkillset,
  getSkillsetID
};
