const express = require('express');
const router = express.Router();
const authController = require('./skillset.controller');
const authMiddleware = require('../../middlewares/authMiddleware');



router.get('/', authMiddleware, authController.getSkillset);
router.get('/:id', authMiddleware, authController.getSkillsetByID);
router.post('/add', authMiddleware, authController.addSkillset);
router.patch('/:id', authMiddleware, authController.editSkillset);
router.delete('/:id', authMiddleware, authController.deleteSkillset);

module.exports = router;


