const express = require('express');
const router = express.Router();
const teamController = require('./team.controller');
const authMiddleware = require('../../middlewares/authMiddleware');

router.get('/stats', authMiddleware, teamController.getEmployeeStats);
router.get('/', authMiddleware, teamController.getTeam);
router.get('/:id', authMiddleware, teamController.getTeamMemberById);
router.post('/add', authMiddleware, teamController.addTeamMember);
router.patch('/edit/:id', authMiddleware, teamController.editTeamMember);
router.delete('/delete/:id', authMiddleware, teamController.deleteTeamMember);
router.patch('/edit-bench-status/:employeeId/:projectId', authMiddleware, teamController.editProjectBenchStatus);
router.post('/add-project/:employeeId', authMiddleware, teamController.addProjectToEmployee);
router.patch('/employee/:employeeId/message', authMiddleware, teamController.updateEmployeeMessageStatus);






module.exports = router;