const express = require('express');
const router = express.Router();
const extensionController = require('./extension.controller');
const authMiddleware = require('../../../middlewares/authMiddleware');

router.post('/request',authMiddleware, extensionController.createExtensionRequest);
router.get('/pending',authMiddleware, extensionController.getPendingExtensions);
router.patch('/:id/status',authMiddleware, extensionController.updateExtensionStatus);
router.get('/history/:projectId',authMiddleware, extensionController.getExtensionHistoryByProjectId);
router.get('/pending/:projectId',authMiddleware, extensionController.getPendingExtensionsByProjectId);

module.exports = router;