const express = require('express');
const router = express.Router();
const projectController = require('./project.controller');
const authMiddleware = require('../../../middlewares/authMiddleware');
const projectSkillsetRoutes = require('../Projectskillset/Projectskillset.route');
const projectCrfrRoutes = require('../Projectcrfr/Projectcrfr.route');

router.get('/status/:tab', authMiddleware, projectController.getAllProjectByStatus);
router.get('/', authMiddleware, projectController.getAllProject);
router.get('/:id', authMiddleware, projectController.getProjectById);
router.patch('/:id', authMiddleware, projectController.editProjectById);
router.post('/add', authMiddleware, projectController.addProject);
router.delete('/:id', authMiddleware, projectController.deleteProjectById);
router.use('/skillset', authMiddleware, projectSkillsetRoutes);
router.use('/crfr', authMiddleware, projectCrfrRoutes);
router.post('/:id/close', authMiddleware, projectController.closeOrReopenProject);

module.exports = router;