const express = require('express');
const router = express.Router();
const teamMemberController = require('./projectTeamMember.controller');
const authMiddleware = require('../../../middlewares/authMiddleware');

router.get('/',authMiddleware, teamMemberController.getProjectTeamMembers);
router.get('/:id',authMiddleware, teamMemberController.getProjectTeamMemberById);
router.post('/add',authMiddleware, teamMemberController.addProjectTeamMember);
router.patch('/edit/:id',authMiddleware, teamMemberController.editProjectTeamMember);
router.delete('/delete/:id',authMiddleware, teamMemberController.deleteProjectTeamMember);
router.get('/project/:projectId',authMiddleware, teamMemberController.getProjectTeamMembersByProjectId);

module.exports = router;
