const express = require('express');
const router = express.Router();
const milestoneController = require('./milestone.controller');
const authMiddleware = require('../../../middlewares/authMiddleware');

router.get('/',authMiddleware, milestoneController.getMilestone);
router.get('/:id',authMiddleware, milestoneController.getMilestoneByID);
router.post('/add',authMiddleware, milestoneController.addMilestone);
router.patch('/edit/:id',authMiddleware, milestoneController.editMilestone);
router.delete('/delete/:id',authMiddleware, milestoneController.deleteMilestone);

module.exports = router;