const ProjectSkillsetService = require('../Projectskillset/Services/Projectskillset.service');

const addSkillsetsToProject = async (req, res) => {
  try {
    const projectId = req.params.projectId;
    const skillsetIds = req.body.skillsetIds;

    const result = await ProjectSkillsetService.addSkillsetsToProject(projectId, skillsetIds);
    res.status(result.status).json(result.data);
  } catch (error) {
    res.status(500).json({ message: 'Internal server error', error });
  }
};

const deleteSkillsetFromProject = async (req, res) => {
  const projectId = req.params.projectId;
  const skillsetId = req.params.skillsetId;

  try {
    const result = await ProjectSkillsetService.deleteSkillsetFromProject(projectId, skillsetId);
    res.status(result.status).json(result.data);
  } catch (error) {
    console.error('Error deleting skillset from project:', error);
    res.status(500).json({ message: 'Internal server error' });
  }
};

const getProjectWithSkillsets = async (req, res) => {
  const { search = '', page = 1, limit = 25 } = req.query;
  const { projectId } = req.params;

  try {
    const result = await ProjectSkillsetService.getProjectWithSkillsets(projectId, search, page, limit);

    // Check if the project is found
    if (result.status !== 200) {
      return res.status(result.status).json({ message: result.message });
    }

    res.status(result.status).json(result.data);
  } catch (error) {
    console.error(error);
    res.status(500).json({ message: 'Internal server error', error });
  }
};



const getProjectSkillset = async (req, res) => {
  try {
    const { search, page = 1, limit = 10 } = req.query;
    const ProjectSkillset = await ProjectSkillsetService.getProjectSkillset(search, page, limit);
    res.json(ProjectSkillset);
  } catch (error) {
    res.status(500).send('Server error');
  }
};

module.exports = {
  deleteSkillsetFromProject,
  getProjectWithSkillsets,
  addSkillsetsToProject,
  getProjectSkillset

};