const express = require('express');
const router = express.Router();
const resourceController = require('./requsestResource.controller');
const authMiddleware = require('../../../middlewares/authMiddleware');

// Add this route to your existing routes file
router.get('/requests/pending',authMiddleware, resourceController.getAllPendingRequests);


// Define a POST route for resource allocation requests
router.post('/request',authMiddleware, resourceController.allocateResources);

// Define a PATCH route for updating the status of a resource request
router.patch('/:id/status',authMiddleware, resourceController.updateRequestStatus);

// Define a GET route to fetch all history for a specific request
router.get('/project/:projectId/history',authMiddleware, resourceController.getAllHistoryByProjectId);

//get all the pending requset 
router.get('/request/pending/:id',authMiddleware, resourceController.getPendingRequestsByProjectId);

module.exports = router;