const express = require('express');
const profileRoutes = require('./modules/Profile/profile.route');
const authenticationRoutes = require('./modules/Authentication/auth.route');
const skillsetRoutes = require('./modules/Skillset/skillset.route');
const teamRoutes = require('./modules/Team/team.route');
const projectRoutes = require('./modules/project/Project/project.route');
const roleRoutes = require('./modules/RolesAndAccess/role.route');
const teamMemberRoutes = require('./modules/project/ProjectTeamMembers/projectTeamMember.route');
const milestoneRoutes = require('./modules/project/Projectmilestone/milestone.route');
const extensionRoutes = require('./modules/project/ExtensionRequest/extension.router');
const requestResource = require('./modules/project/RequestResource/requsestResource.route');
const timesheet = require('./modules/Timesheet/timesheet.route');
const report = require('./modules/Report/report.route');
const mailsendingimage = require('./utils/Eclipse/Eclipse.route');
const settings = require('./modules/Settings/settings.route');
const router = express.Router();

router.use('/profile', profileRoutes);
router.use('/auth', authenticationRoutes);
router.use('/skillset', skillsetRoutes);
router.use('/team', teamRoutes);
router.use('/project', projectRoutes);
router.use('/teamMember', teamMemberRoutes);
router.use('/roles', roleRoutes);
router.use('/milestone', milestoneRoutes);
router.use('/extension', extensionRoutes);
router.use('/requestResource', requestResource);
router.use('/timesheet', timesheet);
router.use('/logos',mailsendingimage);
router.use('/report', report);
router.use('/settings',settings);



module.exports = router;
