const fs = require('fs');
const path = require('path');

/**
 * Convert PNG file to Base64
 * @param {string} fileName - The name of the PNG file
 * @returns {string} - Base64 string of the PNG file
 */
function convertPngToBase64(fileName) {
  const filePath = path.join(__dirname, './logos', fileName);
  const fileBuffer = fs.readFileSync(filePath);
  return `data:image/png;base64,${fileBuffer.toString('base64')}`;
}

// Export the function for use in routes
module.exports = {
  convertPngToBase64,
};
